# Universal Java Matrix Package
> A Java Library for sparse and dense matrices, linear algebra, visualization and big data

The Universal Java Matrix Package (UJMP) is an open source library for dense and sparse matrix computations and linear algebra in Java. In addition to the basic operations like matrix multiplication, matrix inverse or matrix decomposition, it also supports visualization, JDBC import/export and many other useful functions such as mean, correlation, standard deviation, mutual information, or the replacement of missing values.

It's a swiss army knife for data processing in Java, tailored to machine learning applications.

In a Nutshell:
- Dense and sparse matrices in multiple dimensions
- Matrix inverse, pseudo inverse, determinant, SVD, LU, QR, Cholesky, Eigenvalue decomposition
- Multi-threaded and lighting fast
- Handle terabyte-sized matrices on disk
- Visualize and edit as heatmap, graph, plot
- Treat every type of data as a matrix
- TXT, CSV, PNG, JPG, HTML, XLS, XLSX, PDF, LaTeX, Matlab, MDB
- Free and open source (LGPL)

Find out more at
https://ujmp.org
